<!--
"This sample program is provided AS IS and may be used, executed, copied and modified without royalty payment by customer (a) for its own instruction and study, (b) in order to develop applications designed to run with an IBM WebSphere product, either for customer's own internal use or for redistribution by customer, as part of such an application, in customer's own products."

IBM Confidential 
OCO Source Material
5724-L01, 5655-N53
(C) COPYRIGHT International Business Machines Corp. 2005, 2006
The source code for this program is not published or otherwise divested
of its trade secrets, irrespective of what has been deposited with the
U.S. Copyright Office.
-->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<HTML>
<HEAD>
<%@ page language="java" contentType="text/html; charset=ISO-8859-2"%>

<%@ page import="commonj.sdo.DataObject" %>
<%@ page import="commonj.sdo.Type"%>
<%@ page import="com.ibm.websphere.bo.BOFactory" %>
<%@ page import="com.ibm.websphere.sca.ServiceManager" %>
<%@ page import="com.ibm.websphere.sca.Service" %>
<%@ page import="com.ibm.websphere.sca.scdl.Component"%>
<%@ page import="com.ibm.websphere.sca.scdl.OperationType"%>
<%@ page import="com.ibm.websphere.sca.scdl.Reference"%>

<!-- BEGIN TRANSLATION -->
<%!   String title = "SCA (Service Component Architecture) -- Calculator simplu"; %>
<%!   String samples_gallery = "Galerie de exemple"; %>
<%!   String execution_time = "Timp de execuie: "; %>
<%!   String milliseconds_unit = "ms"; %>
<%!   String submit_another_request = "Lansai o alt cerere: "; %>
<%!   String number_format_error = "Operandul trebuie s fie un numr.  Au fost introduse urmtoarele valori: "; %>
<%!	  String operand1 = "Operand 1: "; %>
<%!	  String operand2 = "Operand 2: "; %>
<%!	  String operator = "Operator: "; %>
<%!   String exception = "Excepie: ";  %>
<%!   String addition = "Adunare";  %>
<%!   String subtraction = "Scdere";  %>
<%!   String submit = "Lansare";  %>
<!-- STOP TRANSLATION -->
<%!   String result = "rezultat"; %>


<META name="GENERATOR" content="IBM WebSphere Studio;charset=ISO-8859-2">

<TITLE><%= title %></TITLE>


<!-- Default Stylesheet and Javascript used to set browser and DBCS Stylesheet -->
<link rel='stylesheet' href='/WSsamples/en/SamplesMaster.css'>
<script language="JavaScript" src="/WSsamples/scripts/browserStyle.js"></script>

</head>
<body>
<img src="/WSsamples/images/success_banner.jpg" alt="<%= samples_gallery %>">


<table cellpadding=5 cellspacing=5>
        <tr>
                <td>
                <H1 class="sampjsp"><%= title %></H1>
                </td>
        </tr>
</table>


<HR width=100%>
<%
        if (request.getParameter( "operand1" ) != null ) // the first time the page is shown, do not do the calculation
        {

                try
                {
                     long startTime = System.currentTimeMillis(); // will be used to determine response time

                     // parse the form parameters into usable form

                     int operand1 = Integer.parseInt(request.getParameter( "operand1" ));
                     int operand2 = Integer.parseInt(request.getParameter( "operand2" ));
                     String operatorSymbol;

                     if ( request.getParameter( "Operator" ).equals( "add" ))
                     {
                          operatorSymbol = "+";
                     }
                     else if ( request.getParameter( "Operator" ).equals( "subtract" ))
                     {
                          operatorSymbol = "-";
                     }
                     else // invalid operator specified
                     {
                          throw( new Exception( "An invalid operator was specified: " + request.getParameter( "Operator") ));
                     }

                     // create an instance of the "MathProblem" business object

                     BOFactory boFactory = (BOFactory)ServiceManager.INSTANCE.locateService("com/ibm/websphere/bo/BOFactory");

                     DataObject mathProblemBG = boFactory.create("http://SimpleCalculator_Module", "MathProblemBG");

                     if ( mathProblemBG == null )
                     {
                        throw( new Exception( "mathProblemBG was not found" ));
                     }

                     mathProblemBG.set( "verb", operatorSymbol);  // will be either '+' or '-' based on radio button selection
                     DataObject mathProblemBO = mathProblemBG.createDataObject("MathProblem");
                     mathProblemBO.setInt("operand1", operand1);
                     mathProblemBO.setInt("operand2", operand2);

                        Component context = ServiceManager.INSTANCE.getComponent();
                        Reference reference = context.getReference( "SimpleCalculatorInterfacePartner");
                        // Get the doCalculation operation type
                        OperationType operationType = reference.getOperationType("doCalculation");
                        Type inputType = operationType.getInputType();
                        // out.println("<br>input type=" + inputType.getName());

                        Type outputType = operationType.getOutputType();
                        // out.println("<br>output type=" + outputType.getName());

                     DataObject input = boFactory.createByType(inputType);
                     input.set(0, mathProblemBG);

                     Service simpleCalculator = (Service)ServiceManager.INSTANCE.locateService("SimpleCalculatorInterfacePartner");
                     DataObject responseObj = (DataObject)simpleCalculator.invoke( "doCalculation", input );
                     mathProblemBG = responseObj.getDataObject( 0 );
                     mathProblemBO = (DataObject) mathProblemBG.getDataObject( "MathProblem" );

                     out.print( "<p>" + operand1 + " " + operatorSymbol + " " + operand2 + " = " + mathProblemBO.getInt( result ));

                     long responseTime = System.currentTimeMillis() - startTime;
%>

                     <h2><%= execution_time %> <%=responseTime%> <%= milliseconds_unit %></h2>

                     <hr>

                     <h2><%= submit_another_request %></h2>
<%
                }
                catch( NumberFormatException nfe )
                {
                   out.print( "<h2><font color=\"red\">" + number_format_error + request.getParameter("operand1") + ", " + request.getParameter("operand2") + "</font></h2>");
                }
                catch( Exception e)
                {
                    out.println("<h2><font color=\"red\">" + exception + e + "</font></h2>");
                    e.printStackTrace();
                }
         }

%>

<form action="index.jsp" method="get">
<table>
        <tr>
                <td><%= operand1 %></td>
                <td><input name=operand1 id=operand1></td>
        </tr>
        <tr>
                <td><%= operand2 %></td>
                <td><input name=operand2 id=operand2></td>
        </tr>
        <tr>
                <td><%= operator %></td>
                <td><input name="Operator" type=radio CHECKED value="add"> <%= addition %><br>
                <input name="Operator" type=radio value="subtract"> <%= subtraction %></td>
        </tr>
        <tr>
                <td colspan=2 align=center><input id=action name=action type=submit value="<%= submit %>"></td>
        </tr>
</table>

</form>
</BODY>
</HTML>
